// JavaScript Document
function Cai(game,type,lane){
	this.type='AI';
	this.car=new Ccar(game,type,lane);
	this.position=0;
	this.crash=false;
	this.finished=false;
	this.ERR=0;
	this.WPM=0;
	this.lastTime=0;
	this.crashTime=0;
	this.finishTime=0;
	this.personality=game.config.gameSettings.difficulty[game.difficulty].AI[Math.floor(Math.random()*game.config.gameSettings.difficulty[game.difficulty].AI.length)];
	this.name=game.config.gameSettings.AIOponents[this.personality].name;
	
	this.ready=ready;function ready(){
		this.car.goToStart();
		if(this.car.ready)return(true);
		return(false);
	}
	
	this.getNextTime=getNextTime;function getNextTime(){
		var range=game.config.gameSettings.AIOponents[this.personality].slowest-game.config.gameSettings.AIOponents[this.personality].fastest;
		var ret=game.config.gameSettings.AIOponents[this.personality].slowest+range*Math.random();
		return(Math.floor(ret));
	}
	this.typeTime=this.getNextTime();
	
	this.correct=correct;function correct(){
		var perc=game.config.gameSettings.AIOponents[this.personality].ErrorPercent;
		if(Math.random()*100<perc)return(false);
		return(true);
	}

	this.Run=Run;function Run(){
/*		if(game.status=='playing' || game.status=='greenlight'){
			this.position++;
			this.car.position=this.position*game.config.gameSettings.settings.letterTrackSize;
		}*/
		if(!this.crash && !this.finished)if(game.status=='playing' || game.status=='greenlight'){
			if(this.lastTime==0)this.lastTime=game.time;
			if(game.time-this.lastTime>this.typeTime){
				this.typeTime=this.getNextTime();this.lastTime=game.time;
				if(this.correct()){
					this.position++;
					var key=game.sentence[this.position];
					if(key==' ' || key=='.' || key==',' || key==';'){
						this.car.position=this.position*game.config.gameSettings.settings.letterTrackSize;
						if(this.position>=game.sentence.length){//end race
							this.finished=true;
							this.finishTime=game.time;
						}
						game.SFX.carMoves(lane);
					}
				}else{
					this.ERR++;
					if(this.ERR>=10){
						this.ERR=10;
						this.crash=true;
						this.crashTime=game.time;
					}else if(this.ERR==8){
						game.SFX.addEffect('fire_1',lane);
					}
				}
			}
		}
		if(!this.crash && !this.finished)this.WPM=(this.position*12000)/(game.time-game.raceTime);
		if(this.finished && !this.crash)this.car.position+=game.config.gameSettings.settings.letterTrackSize;
		else if(this.car.position>game.trackLength)this.car.position=game.trackLength;
		this.car.Run();
	}
	
	this.finishRace=finishRace;function finishRace(){
		if(this.crash || this.finished)return;
		var leftLetters=game.sentence.length-this.position;
		var time=game.time;this.finishTime=time;this.finished=true;
		while(this.ERR<10 && this.position<game.sentence.length){
			time+=this.getNextTime();
			if(this.correct()){
				this.position++;
				if(this.position>=game.sentence.length){//end race
					this.finished=true;
					this.finishTime=time;
				}
			}else{
				this.ERR++;
				if(this.ERR>=10){
					this.finished=false;
					this.crash=true;
					this.crashTime=time;
				}
			}
		}
	}
	
	this.Draw=Draw;function Draw(){
		this.car.Draw();
	}
}