// JavaScript Document
function Cui(game){
	this.status=0;
	this.handler=game;
	this.mainDiv=false;
	this.scaleVal=1.0;
	this.LoadingPerc=0;
	this.raceCtx=false;
	this.measuringCtx=false;
	
	this.Load=Load;function Load(){
		if(game.gameDiv)game.gameDiv.innerHTML+='<div id="UIContainer" onmouseover="this.mouseOver=true;" onmouseout="this.mouseOver=false;"></div><div id="loadingContainer" align="center"><div id="loadingRaceLogo"></div><div id="loadingRaceText"></div><div id="loadingBarContainer" align="left"><div id="loadingBar"></div></div></div>';
		this.mainDiv=document.getElementById('UIContainer');
		this.measuringCanvas=document.createElement("canvas");
		this.measuringCtx=this.measuringCanvas.getContext("2d");
	}
	
	this.show=show;function show(display){
		if(!this.mainDiv)return;
		var val;
		if(display)val='block';else val='none';
		if(this.mainDiv.style.display!=val)this.mainDiv.style.display=val;
		var obj=document.getElementById('loadingContainer');
		if(display)val='none';else val='block';
		if(obj.style.display!=val)obj.style.display=val;
	}
	
	this.Run=Run;function Run(gameStatus){
		var set;if(gameStatus==this.status)set=true;else set=false;
		switch(gameStatus){
			case('login screen 1'):this.loginScreen1(set);break;
			case('login screen 2'):this.loginScreen2(set);break;
			case('lobby'):this.race(set);break;
			case('redlight'):case('yellowlight'):case('greenlight'):case('playing'):
				if(this.status)set=true;else set=false;
				this.race(set);break;
			case('RaceReport'):this.raceReport(set);break;
			case('garrage'):this.getGarrage(set);break;
			default:this.mainMenu(set);break;
		}
		this.status=gameStatus;
	}
	
	this.drawLoading=drawLoading;function drawLoading(count, total){
		var obj;
		if(count===true){
			obj=document.getElementById('loadingContainer');
			if(obj){
				
			}
			obj=document.getElementById('loadingRaceLogo');
			if(obj){
				obj.style.backgroundImage='url('+this.handler.homeURL+'assets/images/translate/'+this.handler.language+'/typing_race.png)';
				obj.style.marginTop=(100*this.scaleVal)+'px';
				obj.style.width=(337*this.scaleVal)+'px';
				obj.style.height=(155*this.scaleVal)+'px';
			}
			obj=document.getElementById('loadingRaceText');
			if(obj){
				obj.style.backgroundImage='url('+this.handler.homeURL+'assets/images/translate/'+this.handler.language+'/Loading_text.png)';
				obj.style.marginTop=(200*this.scaleVal)+'px';
				obj.style.width=(124*this.scaleVal)+'px';
				obj.style.height=(38*this.scaleVal)+'px';
			}
			obj=document.getElementById('loadingBarContainer');
			if(obj){
				obj.style.marginTop=(7*this.scaleVal)+'px';
				obj.style.width=(538*this.scaleVal)+'px';
				obj.style.height=(52*this.scaleVal)+'px';
				obj.style.paddingLeft=(12*this.scaleVal)+'px';
				obj.style.paddingTop=(2*this.scaleVal)+'px';
			}
			obj=document.getElementById('loadingBar');
			if(obj){
				obj.style.backgroundSize=(100/this.LoadingPerc)+'%';
				obj.style.width=(526.5*this.scaleVal*this.LoadingPerc)+'px';
				obj.style.height=(36*this.scaleVal)+'px';
			}
			return;
		}
		this.LoadingPerc=count/total;
		if(this.lastLoadPerc!=this.LoadingPerc){
			obj=document.getElementById('loadingBar');
			if(obj){
				obj.style.height=(36*this.scaleVal)+'px';
				obj.style.width=(526.5*this.scaleVal*this.LoadingPerc)+'px';
				obj.style.backgroundSize=(100/this.LoadingPerc)+'%';
			}
			this.lastLoadPerc=this.LoadingPerc;
		}
	}
	
	this.getButtonCode=getButtonCode;function getButtonCode(id,src,srcH,width,height,callFunc){
		if(!this.handler.assets.Data.Images[src])return('ERROR LOADING IMAGE '+src+' !');
		if(!this.handler.assets.Data.Images[srcH])return('ERROR LOADING IMAGE '+srcH+' !');
		if(!callFunc)callFunc='getButtonCode';
		if(width==0)width=parseInt(this.handler.assets.Data.Images[src].width);
		if(height==0)height=parseInt(this.handler.assets.Data.Images[src].height);
		var html='<input type="image" src="'+this.handler.assets.Data.Images[src].src+'" onmouseover="this.src=\''+this.handler.assets.Data.Images[srcH].src+'\';" onmouseout="this.src=\''+this.handler.assets.Data.Images[src].src+'\';" style="border:0px;width:'+(width*this.scaleVal)+'px;height:'+(height*this.scaleVal)+'px;" onclick="game.UI.'+callFunc+'();" />';
		return(html);
	}

	this.getPanelCode=getPanelCode;function getPanelCode(id,src,srcH,width,height,left,top,fontFamily,fontSize,txt,callFunc,resizeFont){
		if(!this.handler.assets.Data.Images[src])return('ERROR LOADING IMAGE '+src+' !');
		if(!this.handler.assets.Data.Images[srcH])return('ERROR LOADING IMAGE '+srcH+' !');
		if(width==0)width=parseInt(this.handler.assets.Data.Images[src].width);
		if(height==0)height=parseInt(this.handler.assets.Data.Images[src].height);
		width-=left*2;height-=top;
		width*=this.scaleVal;fontSize*=this.scaleVal;
		if(resizeFont){
			this.measuringCtx.font=fontSize+"px "+fontFamily;
			var w=this.measuringCtx.measureText(txt).width;
			while(w>width && fontSize>0){
				fontSize-=0.1;
				this.measuringCtx.font=fontSize+"px "+fontFamily;
				w=this.measuringCtx.measureText(txt).width;
			}
		}
		var html='<div onmouseover="this.style.backgroundImage=\'url('+this.handler.assets.Data.Images[srcH].src+')\';" onmouseout="this.style.backgroundImage=\'url('+this.handler.assets.Data.Images[src].src+')\';" style="background-image:url(\''+this.handler.assets.Data.Images[src].src+'\');background-size:100% 100%;border:0px;width:'+(width)+'px;height:'+(height*this.scaleVal)+'px;';
		html+='padding-left:'+(left*this.scaleVal)+'px;padding-right:'+(left*this.scaleVal)+'px;padding-top:'+(top*this.scaleVal)+'px;';
		html+='font:'+(fontSize)+'px '+fontFamily+';';
		if(callFunc)html+='cursor:pointer;';
		html+='"';
		if(callFunc)html+='" onclick="game.UI.'+callFunc+'();"';
		html+=' align="center"><span style="line-height:'+(height*this.scaleVal)+'px;">'+txt+'</span>';
		html+='</div>';
		return(html);
	}
	
	this.getTextWidth=getTextWidth;function getTextWidth(txt,fontFamily,fontSize){
		this.measuringCtx.font=fontSize+"px "+fontFamily;
		var w=this.measuringCtx.measureText(txt).width;
		return(w);
	}
	
	this.getTextButtonCode=getTextButtonCode;function getTextButtonCode(text,classN,width,height,font_size,textX,textY,callFunc){
		var w=Math.round(width*this.scaleVal);
		var h=Math.round(height*this.scaleVal);
		var fSize=font_size*this.scaleVal;
		var marginW=0;
		if(this.handler.assets.Data.Images['margin'+classN])
			marginW=Math.round(this.handler.assets.Data.Images['margin'+classN].width*height/this.handler.assets.Data.Images['margin'+classN].height*this.scaleVal);
		textX*=this.scaleVal;textY*=this.scaleVal;
		if(textX>0){padding='left';}else{padding='right';textX=-textX;}
		var html='<div class="button_'+classN+'"';
		if(callFunc)html+=' onmouseover="this.className=\'button_'+classN+'On\';" onmouseout="this.className=\'button_'+classN+'\';" ';
		html+=' style="width:'+w+'px;height:'+h+'px;font-size:'+fSize+'px;';
		if(callFunc)html+='cursor:pointer;';else html+='cursor:default;';
		html+='"';
		if(callFunc)html+='" onclick="game.UI.'+callFunc+'();"';
		html+=' align="center">';
		html+='<div style="clear:both"></div>';
		html+='<div class="buttonMargin" style="width:'+marginW+'px;"></div>';
		html+='<div class="buttonMiddle" style="padding-'+padding+':'+textX+'px;width:'+(w-2*marginW-textX)+'px;"><div style="margin-top:'+textY+'px;line-height:'+(h-textY)+'px;">'+text+'</div></div>';
		html+='<div class="buttonMargin flippedImg" style="width:'+marginW+'px;"></div>';
		html+='<div style="clear:both"></div>';
		html+='</div>';
		return(html);
	}
	
	this.showPopup=showPopup;function showPopup(code){
		var obj,html;
		obj=document.getElementById('popupContainer');
		if(!obj){
			html='<div id="popupContainer" style="position:absolute;background-image:url(\''+this.handler.assets.Data.Images.PopupBg.src+'\');background-repeat:no-repeat;background-size:100%;z-index:100;width:'+(350*this.scaleVal)+'px;height:'+(400*this.scaleVal)+'px;top:'+(100*this.scaleVal)+'px;margin-left:'+(280*this.scaleVal)+'px;"><div>';
			this.mainDiv.innerHTML+=html;
		}
		obj=document.getElementById('popupContainer');
		obj.innerHTML=code;
		obj.style.display='block';
		obj.onclick=function(){
			game.UI.mainDiv.onclick='';
			setTimeout(function(){game.UI.mainDiv.onclick=hidePopup;},500);
		}
		setTimeout(function(){game.UI.mainDiv.onclick=hidePopup;},500);
	}
	
	this.hidePopup=hidePopup;function hidePopup(){
		var obj=document.getElementById('popupContainer');
		if(obj)obj.style.display='none';
		game.UI.mainDiv.onclick='';
	}
	
	this.focusInput=focusInput;function focusInput(){
		var obj=document.getElementById('raceInput');
		if(obj)obj.focus();
	}

	this.loginScreen1=loginScreen1;function loginScreen1(set){
		var html;
		if(set){
		}else{
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.LoginBackground.src+"')";
			this.mainDiv.style.backgroundPosition='center';
			html='<div style="position:relative;padding-top:'+(300*this.scaleVal)+'px;width:100%;">'+this.getTextButtonCode(this.handler.config.menuTexts.Login,'52',226,52,32,0,0,'loginButtonPress')+'</div>';
			html+='<div style="position:relative;padding-top:'+(30*this.scaleVal)+'px;width:100%;">'+this.getTextButtonCode(this.handler.config.menuTexts.Guest,'52',226,52,32,0,0,'guestButtonPress')+'</div>';
			this.mainDiv.innerHTML=html;
		}
	}

	this.loginScreen2=loginScreen2;function loginScreen2(set){
		if(set){
		}else{
			var html='',providers,i;
			this.mainDiv.style.backgroundImage="none";
			if(GSP)providers=GSP.getSocialProviders();else providers=new Array();
			html+='<div align="center" style="position:absolute;margin-top:'+(50*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;"><div style="position:relative;width:'+(337*this.scaleVal)+'px;height:'+(155*this.scaleVal)+'px;background-image:url('+this.handler.homeURL+'assets/images/translate/'+this.handler.language+'/typing_race.png);background-size:100%;" align="center"></div></div>';
			html+='<div align="center" style="position:absolute;margin-top:'+(320*this.scaleVal)+'px;width:'+(960*this.scaleVal)+'px;">';
			for(i=0;i<providers.length;i++){
				html+='<span style="padding:'+(30*this.scaleVal)+'px;">'+this.getButtonCode(providers[i],providers[i],providers[i]+'H',0,0,'Login(\''+providers[i]+'\');console.log')+'</span>';
			}
			html+='</div>';
//			html+='<div style="position:relative;padding-top:'+(300*this.scaleVal)+'px;width:100%;">'+this.getButtonCode('LoginButton','LoginButton','LoginButtonH',0,0,'loginButtonPress')+'</div>';
//			html+='<div style="position:relative;padding-top:'+(30*this.scaleVal)+'px;width:100%;">'+this.getButtonCode('GuestButton','GuestButton','GuestButtonH',228,68,'guestButtonPress')+'</div>';
			this.mainDiv.innerHTML=html;
		}
	}
	
	this.Login=Login;function Login(provider){
		login(provider);
	}

	this.loginButtonPress=loginButtonPress;function loginButtonPress(){
		this.handler.status='login screen 2';
	}
	
	this.guestButtonPress=guestButtonPress;function guestButtonPress(){
		this.handler.player={
			info:{
				name:'Guest'
			},
			carType:Math.floor(Math.random()*this.handler.config.gameSettings.cars.length)
		}
		this.handler.status='main menu set';
	}
	
	this.mainMenu=mainMenu;function mainMenu(set){
		if(this.handler.loadingStage<1)return;
		if(!this.handler.player){this.loginScreen1(set);return;}
		if(set){
		}else{
			var html='';
			html+='<div id="mainMenuTopBar">';
			if(this.handler.soundOn)
				html+='<div style="float:left;padding-top:'+(8*this.scaleVal)+'px;" id="soundSettingsContainer">'+this.getButtonCode('SoundButton','soundON','soundON',0,0,'soundButtonPress')+'</div>';
			else
				html+='<div style="float:left;padding-top:'+(8*this.scaleVal)+'px;" id="soundSettingsContainer">'+this.getButtonCode('SoundButton','soundOFF','soundOFF',0,0,'soundButtonPress')+'</div>';
			html+='<div style="float:left;padding-left:'+(30*this.scaleVal)+'px;padding-top:'+(6*this.scaleVal)+'px;">'+this.getPanelCode('playerName','EmptyButtonH','EmptyButtonH',0,0,5,0,'airstrike',24,this.handler.player.info.name,false,true,true)+'</div>';
			html+='<div style="float:left;padding-left:'+(30*this.scaleVal)+'px;padding-top:'+(7*this.scaleVal)+'px;">'+this.getTextButtonCode('<img align="absmiddle" width="'+(46*this.scaleVal)+'" height="'+(29*this.scaleVal)+'" src="'+this.handler.assets.Data.Images.flag.src+'" style="padding-right:'+(10*this.scaleVal)+'px;" />'+this.handler.config.gameSettings.language.text,'65',150,42,30,0,0,'languageSelect')+'</div>';
			html+='<div style="float:left;padding-left:'+(30*this.scaleVal)+'px;padding-top:'+(8*this.scaleVal)+'px;">'+this.getPanelCode('HighScoresButton','HighScoresButton','HighScoresButtonH',0,0,0,0,'',0,'','highScoresButtonPress',true,true)+'</div>';
			html+='</div>';
			html+='<div style="position:absolute;margin-top:'+(82*this.scaleVal)+'px;margin-left:'+(365*this.scaleVal)+'px;">'+this.getButtonCode('GarrageButton','GarrageButton','GarrageButtonH',0,0,'garrageButtonPress')+'</div>';
			html+='<div id="mainMenuBottomBar">';
			html+='<div style="float:left;padding-left:'+(20*this.scaleVal)+'px;padding-top:'+(20*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.GoToGarage,'gotogarage',288,182,30,5,35,'garrageButtonPress')+'</div>';
			html+='<div style="float:left;padding-left:'+(20*this.scaleVal)+'px;padding-top:'+(10*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.SoloRace,'solorace',288,195,31,7,44,'soloButtonPress')+'</div>';
			html+='<div style="float:left;padding-left:'+(20*this.scaleVal)+'px;padding-top:'+(10*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Multiplayer,'multiplayer',311,193,31,7,45,'multiButtonPress')+'</div>';
			html+='</div>';
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.MainMenuBg.src+"')";
			this.mainDiv.style.backgroundPosition='center';
			this.mainDiv.innerHTML=html;
		}
	}
	
	this.soundButtonPress=soundButtonPress;function soundButtonPress(){
		var obj=document.getElementById('soundSettingsContainer');
		if(!obj)return;
		if(this.handler.soundOn){
			this.handler.soundOn=false;
			obj.innerHTML=this.getButtonCode('SoundButton','soundOFF','soundOFF',0,0,'soundButtonPress');
		}else{
			this.handler.soundOn=true;
			obj.innerHTML=this.getButtonCode('SoundButton','soundON','soundON',0,0,'soundButtonPress');
		}
	}
	
	this.languageSelect=languageSelect;function languageSelect(){
		var html,i,lang=this.handler.config.gameSettings.language.list;
		html='<table cellspacing="0" cellpadding="'+(10*this.scaleVal)+'" border="0" style="padding:'+(5*this.scaleVal)+'px;padding-top:'+(10*this.scaleVal)+'px;"><tr>';
		for(i=0;i<lang.length;i++){
			html+='<td>'+this.getTextButtonCode('<img align="absmiddle" width="'+(46*this.scaleVal)+'" height="'+(29*this.scaleVal)+'" src="'+this.handler.assets.Data.Images['flag_'+i].src+'" style="padding-right:'+(10*this.scaleVal)+'px;" />'+lang[i].text,'65',150,42,30,0,0,'emptyFunc();game.language=\''+lang[i].folder+'\';game.UI.languageChange')+'</td>';
			if(i<lang.length-1 && i%2)html+='</tr><tr>';
		}
		html+='</tr></table>';
		this.showPopup(html);
	}
	
	this.emptyFunc=emptyFunc;function emptyFunc(){}
	
	this.languageChange=languageChange;function languageChange(){
		this.handler.loadingStage=0;
		var i,lang=this.handler.config.gameSettings.language.list
		for(i=0;i<lang.length;i++)if(lang[i].folder==this.handler.language){
			configURL=lang[i].config;
		}
		this.handler.Load(true);
	}
	
	this.highScoresButtonPress=highScoresButtonPress;function highScoresButtonPress(){
	}
	
	this.garrageButtonPress=garrageButtonPress;function garrageButtonPress(){
		this.handler.LoadGarrage();
	}
	
	this.difficultySelect=difficultySelect;function difficultySelect(){
		var html;
		var sz=34;
		html='<div align="center" style="color:#fff;padding-left:'+(2*this.scaleVal)+'px;height:'+(50*this.scaleVal)+'px;margin-top:'+(30*this.scaleVal)+'px;font:'+(sz*this.scaleVal)+'px airstrike;">'+this.handler.config.menuTexts.Difficulty+'</div>';
		html+='<div align="center" style="color:#000;margin-top:-'+(51*this.scaleVal)+'px;font:'+(sz*this.scaleVal)+'px airstrike;">'+this.handler.config.menuTexts.Difficulty+'</div>';
		html+='<div align="center" style="margin-top:'+(20*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Easy,'65',205,60,30,0,0,'startEasy')+'</div>';
		html+='<div align="center" style="margin-top:'+(30*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Medium,'65',205,60,30,0,0,'startMedium')+'</div>';
		html+='<div align="center" style="margin-top:'+(30*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Hard,'65',205,60,30,0,0,'startHard')+'</div>';
		this.showPopup(html);
	}
	
	this.startEasy=startEasy;function startEasy(){
		this.handler.difficulty=0;
		this.handler.LoadGameData();
	}
	
	this.startMedium=startMedium;function startMedium(){
		this.handler.difficulty=1;
		this.handler.LoadGameData();
	}
	
	this.startHard=startHard;function startHard(){
		this.handler.difficulty=2;
		this.handler.LoadGameData();
	}
	
	this.soloButtonPress=soloButtonPress;function soloButtonPress(){
		this.handler.gameType='single';
		this.handler.cars=false;
		this.difficultySelect();
	}
	
	this.multiButtonPress=multiButtonPress;function multiButtonPress(){
		this.handler.gameType='multi';
		this.handler.cars=false;
		this.difficultySelect();
	}

	this.race=race;function race(set){
		var i;
		if(set){
			var obj;
			if(!this.raceCtx)return;
//			this.mainDiv.style.backgroundPosition='-'+parseInt(this.handler.trackPan*this.scaleVal)+'px 0px';
			this.mainDiv.style.backgroundPosition='-'+parseInt(this.handler.trackPos*this.scaleVal)+'px 0px';
			this.raceCtx.clearRect(0,0,parseInt(960*this.scaleVal),parseInt(640*this.scaleVal));
			if(295-this.handler.trackPos>0){//start line
				this.raceCtx.drawImage(this.handler.assets.Data.Images.Start,(200-this.handler.trackPos)*this.scaleVal,286*this.scaleVal,95*this.scaleVal,290*this.scaleVal);
			}
			if(this.handler.endPos){//finish line
				this.raceCtx.drawImage(this.handler.assets.Data.Images.Finish,(960+this.handler.endPos-this.handler.trackPos)*this.scaleVal,286*this.scaleVal,95*this.scaleVal,290*this.scaleVal);
			}
/*			if(this.handler.trackPan>this.handler.trackLength-900){//finish line
				this.raceCtx.drawImage(this.handler.assets.Data.Images.Finish,(160+this.handler.trackLength-this.handler.trackPan)*this.scaleVal,286*this.scaleVal,95*this.scaleVal,290*this.scaleVal);
			}*/
			//cars
			for(i=0;i<this.handler.cars.length;i++){
				this.handler.SFX.Run(i);
				this.handler.cars[i].Draw();
			}
			//switchlighr
			var h=0,stage;
			if(this.status=='redlight'){
				obj=document.getElementById('waitingContainer');if(obj)obj.style.display='none';
				obj=document.getElementById('waitingText');if(obj)obj.style.display='none';
				stage=(this.handler.time-this.handler.raceTime)/(this.handler.config.gameSettings.settings.lightTimer/2);
				h=this.handler.assets.Data.Images.RedLight.height*stage-this.handler.assets.Data.Images.RedLight.height;
				if(h>0)h=0;
				this.raceCtx.drawImage(this.handler.assets.Data.Images.RedLight,600*this.scaleVal,h*this.scaleVal,this.handler.assets.Data.Images.RedLight.width*this.scaleVal,this.handler.assets.Data.Images.RedLight.height*this.scaleVal);
			}else
			if(this.status=='yellowlight'){
				this.raceCtx.drawImage(this.handler.assets.Data.Images.YellowLight,600*this.scaleVal,0,this.handler.assets.Data.Images.RedLight.width*this.scaleVal,this.handler.assets.Data.Images.YellowLight.height*this.scaleVal);
			}else
			if(this.status=='greenlight'){
				stage=(this.handler.time-this.handler.raceTime)/(this.handler.config.gameSettings.settings.lightTimer/2);
				h=this.handler.assets.Data.Images.RedLight.height-this.handler.assets.Data.Images.RedLight.height*stage;
				if(h>0)h=0;
				this.raceCtx.drawImage(this.handler.assets.Data.Images.GreenLight,600*this.scaleVal,h*this.scaleVal,this.handler.assets.Data.Images.RedLight.width*this.scaleVal,this.handler.assets.Data.Images.GreenLight.height*this.scaleVal);
			}
			//WPM clock
			var scaleClocks=1.0,angle;
			var count=this.handler.cars[this.handler.player.carID].WPM;
			angle=0.75*Math.PI+count*0.0078*Math.PI;
			this.angle+=0.05;
			this.raceCtx.drawImage(this.handler.assets.Data.Images.WPMclock,843*this.scaleVal,520*this.scaleVal,this.handler.assets.Data.Images.WPMclock.width*this.scaleVal*scaleClocks,this.handler.assets.Data.Images.WPMclock.height*this.scaleVal*scaleClocks);
			drawRotPic(this.handler.assets.Data.Images.WPMdial,895,571,scaleClocks,angle,7.8,8.7,this.raceCtx,this.scaleVal);
			//ERR clock
			count=this.handler.cars[this.handler.player.carID].ERR;
			angle=(0.5+0.15*count)*Math.PI;
			this.raceCtx.drawImage(this.handler.assets.Data.Images.ErrorClock,740*this.scaleVal,540*this.scaleVal,this.handler.assets.Data.Images.ErrorClock.width*this.scaleVal*scaleClocks,this.handler.assets.Data.Images.ErrorClock.height*this.scaleVal*scaleClocks);
			drawRotPic(this.handler.assets.Data.Images.ErrorDial,784,583,scaleClocks,angle,6.5,7.1,this.raceCtx,this.scaleVal);
			//Acc display
			obj=document.getElementById('ACCBox');
			if(obj){
				if(this.handler.cars[this.handler.player.carID].ERR>this.handler.cars[this.handler.player.carID].position)
					obj.innerHTML='0%';
				else if(this.handler.cars[this.handler.player.carID].position>0)
					obj.innerHTML=Math.round(100-(this.handler.cars[this.handler.player.carID].ERR*100/this.handler.cars[this.handler.player.carID].position))+'%';
				else
					obj.innerHTML='100%';
			}
			//time display
			if(this.status=='greenlight' || this.status=='playing'){
				var time=this.handler.time-this.handler.raceTime;
				var hours=Math.floor(time/3600000);
				time-=hours*3600000;
				if(hours<=9)hours='0'+hours;else hours=hours+' ';
				var minutes=Math.floor(time/60000);
				if(minutes<=9)minutes='0'+minutes;else minutes=minutes+' ';
				time-=minutes*60000;
				var seconds=Math.floor(time/1000);
				if(seconds<=9)seconds='0'+seconds;else seconds=seconds+' ';
				obj=document.getElementById('hour1');if(obj)obj.innerHTML=hours[0];
				obj=document.getElementById('hour2');if(obj)obj.innerHTML=hours[1];
				obj=document.getElementById('min1');if(obj)obj.innerHTML=minutes[0];
				obj=document.getElementById('min2');if(obj)obj.innerHTML=minutes[1];
				obj=document.getElementById('sec1');if(obj)obj.innerHTML=seconds[0];
				obj=document.getElementById('sec2');if(obj)obj.innerHTML=seconds[1];
			}
			if(this.showHint && this.handler.time>this.handler.hintStart+this.handler.config.gameSettings.settings.hintDuration){
				this.showHint=false;
				this.setSentence('Arial',26);
			}
		}else{
			var html='';
			html+='<canvas id="raceCanvas" style="position:absolute;margin-left:-'+(480*this.scaleVal)+'px;margin-top:0px;z-index:5;" width="'+(960*this.scaleVal)+'" height="'+(640*this.scaleVal)+'"></canvas>';
			html+='<div id="waitingContainer" style="width:'+(960*this.scaleVal)+'px;height:'+(256*this.scaleVal)+'px;"></div>';
			html+='<div id="waitingText" style="position:absolute;color:#eee;text-shadow: '+(3*this.scaleVal)+'px '+(2*this.scaleVal)+'px #000;opacity:1.0;margin-top:'+(100*this.scaleVal)+'px;margin-left:0px;font:'+(38*this.scaleVal)+'px airstrike;width:'+(920*this.scaleVal)+'px;height:'+(54*this.scaleVal)+'px;background-image:url(\''+this.handler.assets.Data.Images.ActionBar.src+'\');background-size:100% 100%;padding-top:'+(15*this.scaleVal)+'px;padding-left:'+(40*this.scaleVal)+'px;" align="left">'+this.handler.config.menuTexts.waiting+'</div>';
			for(i=0;i<5;i++)if(this.handler.cars[i]){
				html+='<div style="color:#fff;position:absolute;z-index:15;margin-left:'+(5*this.scaleVal)+'px;margin-top:'+((300+i*52)*this.scaleVal)+'px;font:'+(15*this.scaleVal)+'px Arial;">'+this.handler.cars[i].name+'</div>';
			}
			html+='<div id="TimeBox" style="position:absolute;color:#fff;margin-left:'+(540*this.scaleVal)+'px;margin-top:'+(593*this.scaleVal)+'px;z-index:12;padding-top:'+(3*this.scaleVal)+'px;padding-left:'+(0*this.scaleVal)+'px;width:'+(171*this.scaleVal)+'px;height:'+(33*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.Time.src+'\');font:'+(24*this.scaleVal)+'px Arial;" align="left"><table cellspacing="0" cellpadding="'+(3*this.scaleVal)+'" border="0"><tr><td style="padding-left:'+(19*this.scaleVal)+'px;" id="hour1">0</td><td id="hour2">0</td><td style="padding-left:'+(15*this.scaleVal)+'px;" id="min1">0</td><td id="min2">0</td><td style="padding-left:'+(16*this.scaleVal)+'px;" id="sec1">0</td><td id="sec2">0</td></tr></table></div>';
			html+='<div style="position:absolute;margin-left:'+(340*this.scaleVal)+'px;margin-top:'+(593*this.scaleVal)+'px;z-index:12;padding-top:'+(3*this.scaleVal)+'px;padding-left:'+(90*this.scaleVal)+'px;width:'+(81*this.scaleVal)+'px;height:'+(33*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.ACC.src+'\');font:'+(24*this.scaleVal)+'px Arial;" align="left"><div style="font:'+(26*this.scaleVal)+'px Arial;color:#fff200;margin-left:-'+(80*this.scaleVal)+'px;float:left;">'+this.handler.config.menuTexts.ACC+'.</div><div style="float:left;" id="ACCBox">100%</div></div>';
			html+='<div style="position:absolute;margin-left:'+(40*this.scaleVal)+'px;margin-top:'+(535*this.scaleVal)+'px;z-index:12;padding:'+(5*this.scaleVal)+'px;width:'+(666*this.scaleVal)+'px;height:'+(32*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.TypingFrame.src+'\');" align="left"><div id="typingArea" style="position:absolute;overflow:hidden;width:'+(656*this.scaleVal)+'px;margin-left:'+(5*this.scaleVal)+'px;"><div id="typingInnerArea"></div></div></div>';
			if(true){
				//hints
				html+='<div id="HintsBoxContainer" style="position:absolute;margin-left:'+(140*this.scaleVal)+'px;margin-top:'+(593*this.scaleVal)+'px;z-index:12;padding-top:'+(4*this.scaleVal)+'px;padding-left:'+(90*this.scaleVal)+'px;width:'+(81*this.scaleVal)+'px;height:'+(33*this.scaleVal)+'px;background-size:100% 100%;background-image:url(\''+this.handler.assets.Data.Images.HintBG.src+'\');font:'+(24*this.scaleVal)+'px Arial;" align="left"><div style="font:'+(26*this.scaleVal)+'px Arial;color:#fff200;margin-left:-'+(80*this.scaleVal)+'px;float:left;">'+this.handler.config.menuTexts.HINTS+'</div><div style="float:left;width:'+75*this.scaleVal+'px;padding-top:'+(2*this.scaleVal)+'px;" id="HintsBox" align="center"></div></div>';
				//hints button
				html+='<div id="hintButtonContainer" style="position:absolute;margin-left:'+(20*this.scaleVal)+'px;margin-top:'+(531*this.scaleVal)+'px;z-index:12;padding-top:'+(4*this.scaleVal)+'px;">'+this.getButtonCode('hintButton','hintButton','hintButton',0,0,'hintButtonPress')+'</div>';
				//replay button
				html+='<div id="replayButtonContainer" style="position:absolute;margin-left:'+(20*this.scaleVal)+'px;margin-top:'+(587*this.scaleVal)+'px;z-index:12;padding-top:'+(4*this.scaleVal)+'px;">'+this.getButtonCode('replayButton','replay','replay',0,0,'replayButtonPress')+'</div>';
			}
			html+='<div style="raceInputContainer"><input type="text" id="raceInput" onkeyup="game.keyPressed();" /></div>';
			this.mainDiv.innerHTML=html;
			this.setSentence('Arial',26);
			this.showHints();
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.raceBG.src+"')";
			this.mainDiv.style.backgroundPosition='0px 0px';
			this.raceCtx=document.getElementById('raceCanvas').getContext("2d");
			this.mainDiv.onclick=this.focusInput;
			this.focusInput();
			var obj=document.getElementById('raceInput');
			if(obj)obj.lastSize=0;
			if(this.handler.SFX)this.handler.SFX.effects=new Array();
		}
	}
	
	this.hintButtonPress=hintButtonPress;function hintButtonPress(){
		this.focusInput();
		if(this.handler.hints<=0)return;
		this.handler.hints--;
		this.showHints();
		this.handler.hintStart=this.handler.time;
		this.showHint=true;
		this.setSentence('Arial',26);
		this.showHints();
	}
	
	this.showHints=showHints;function showHints(){
		var obj=document.getElementById('HintsBox');
		if(!obj)return;
		var i,html='';
		var img=this.handler.assets.Data.Images.hintIcon;
		for(i=0;i<this.handler.hints;i++){
			html+='<img src="'+img.src+'" width="'+(img.width*this.scaleVal)+'px" height="'+(img.height*this.scaleVal)+'px" style="padding-left:'+(2*this.scaleVal)+'px;" />';
		}
		obj.innerHTML=html;
		if(this.handler.hints<=0 || !this.handler.sentenceAudio){
			obj=document.getElementById('HintsBoxContainer');
			if(obj)obj.style.display='none';
			obj=document.getElementById('hintButtonContainer');
			if(obj)obj.style.display='none';
		}else{
			obj=document.getElementById('HintsBoxContainer');
			if(obj)obj.style.display='block';
			obj=document.getElementById('hintButtonContainer');
			if(obj)obj.style.display='block';
		}
	}
	
	this.replayButtonPress=replayButtonPress;function replayButtonPress(){
		this.handler.playSentenceAudio=true;
		this.focusInput();
	}
	
	this.setSentence=setSentence;function setSentence(fontFamily,fontSize){
		var obj=document.getElementById('typingInnerArea');
		if(!obj)return;
		if(this.handler.currentSentence<this.handler.sentences.length-1){
			if(this.handler.currentLetter>=this.handler.sentences[this.handler.currentSentence+1].start){
				this.handler.setCurrentSentence(this.handler.currentSentence+1);
				this.showHints();
			}
		}
		fontSize*=this.scaleVal;
		obj.style.font=fontSize+"px "+fontFamily;
		this.measuringCtx.font=fontSize+"px "+fontFamily;
		var txt,w;
		if(this.handler.sentenceAudio && !this.showHint){
			txt=this.handler.sentences[this.handler.currentSentence].text.substring(0,this.handler.currentLetter-this.handler.sentences[this.handler.currentSentence].start)+'_';
			w=this.measuringCtx.measureText(this.handler.sentences[this.handler.currentSentence].text+'_').width;
		}else{
			txt=this.handler.getHtmlSentence();
			w=this.measuringCtx.measureText(this.handler.sentences[this.handler.currentSentence].text).width;
		}
		obj.style.width=w+'px';
		obj.innerHTML=txt;
		obj=document.getElementById('typingArea');
		if(!obj)return;
		var left=this.handler.sentences[this.handler.currentSentence].text.substring(0,this.handler.currentLetter-this.handler.sentences[this.handler.currentSentence].start);
		left=this.measuringCtx.measureText(left).width;
		left-=333*this.scaleVal;
		if(left>0){
			obj.scrollLeft=left;
		}
		if(this.handler.sentenceAudio){
			obj=document.getElementById('replayButtonContainer');
			if(obj)obj.style.display='block';
		}else{
			obj=document.getElementById('replayButtonContainer');
			if(obj)obj.style.display='none';
		}
	}
	
	this.raceReport=raceReport;function raceReport(set){
		if(set){
		}else{
			this.handler.computePoints();
			var html='',i;
			html+='<div class="emptyBackground" style="background-image:url('+this.handler.assets.Data.Images.emptyBG.src+');height:'+(640*this.scaleVal)+'px;background-size:cover;">';
			html+='<div id="waitingText" style="position:absolute;color:#eee;text-shadow: '+(3*this.scaleVal)+'px '+(2*this.scaleVal)+'px #000;margin-top:0px;margin-left:0px;font:'+(48*this.scaleVal)+'px airstrike;width:'+(910*this.scaleVal)+'px;height:'+(54*this.scaleVal)+'px;background-image:url(\''+this.handler.assets.Data.Images.ActionBar.src+'\');background-size:100% 100%;padding-top:'+(10*this.scaleVal)+'px;padding-left:'+(50*this.scaleVal)+'px;" align="left">'+this.handler.config.menuTexts.raceResults+'</div>';
			html+='<div style="position:absolute;margin-top:'+(70*this.scaleVal)+'px;margin-left:0px;border:0px;width:'+(960*this.scaleVal)+'px;">';
			this.handler.cars.sort(function(a,b){if(a.crash && b.crash)return(b.position-a.position);else if(a.crash)return(1);else if(b.crash)return(-1);else return(a.finishTime-b.finishTime);});
			for(i=0;i<this.handler.cars.length;i++){
				html+='<div style="float:left;padding:'+(10*this.scaleVal)+'px;">'+this.getEndCarReport(i,i+1)+'</div>';
			}
			html+='<div style="clear:both"></div></div>';
			html+='<div style="position:absolute;margin-top:'+(300*this.scaleVal)+'px;">';
			html+=this.getPlayerCarReport();
			html+='</div>';
			html+='<div style="position:absolute;margin-top:'+(560*this.scaleVal)+'px;">';
				html+='<div style="float:left;margin-left:'+(30*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.MainMenu,'64',180,55,24,0,0,'mainMenuButtPress')+'</div>';
				html+='<div style="float:left;margin-left:'+(180*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Garage,'64',180,55,24,0,0,'garrageButtonPress')+'</div>';
				html+='<div style="float:left;margin-left:'+(180*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.RaceAgain,'64',180,55,24,0,0,'raceAgainButtPress')+'</div>';
			html+='</div>';
			html+='</div>';
			this.mainDiv.innerHTML=html;
			this.mainDiv.style.backgroundImage='';
		}
	}
	
	this.mainMenuButtPress=mainMenuButtPress;function mainMenuButtPress(){
		this.handler.status='main menu';
	}
	
	this.raceAgainButtPress=raceAgainButtPress;function raceAgainButtPress(){
		this.handler.LoadGameData();
	}
	
	this.getEndCarReport=getEndCarReport;function getEndCarReport(index,place){
		var html=''
		var car=this.handler.cars[index];
		var img=this.handler.assets.Data.Images['carImg_'+car.car.carType+'_0'];
		var fontSize=18*this.scaleVal,fontFamily='Arial';
		this.measuringCtx.font=fontSize+"px "+fontFamily;
		var w=this.measuringCtx.measureText(car.name).width;
		while(w>140*this.scaleVal && fontSize>0){
			fontSize-=0.1;
			this.measuringCtx.font=fontSize+"px "+fontFamily;
			w=this.measuringCtx.measureText(car.name).width;
		}
		html+='<div style="width:'+(168*this.scaleVal)+'px;padding-top:'+(80-img.height/2.2)+'px;" align="center">';
		html+='<img src="'+img.src+'" width="'+(img.width*this.scaleVal/2.2)+'" height="'+(img.height*this.scaleVal/2.2)+'" />';
		html+='<div style="font:'+(28*this.scaleVal)+'px airstrike;padding-top:'+(20*this.scaleVal)+'px;">'+place+((place==1)?this.handler.config.menuTexts.st:((place==2)?this.handler.config.menuTexts.nd:((place==3)?this.handler.config.menuTexts.rd:this.handler.config.menuTexts.th)))+' '+this.handler.config.menuTexts.PLACE+'</div>';
		html+='<div style="font:'+(fontSize)+'px Arial;padding-top:'+(5*this.scaleVal)+'px;height:'+(30*this.scaleVal)+'px;">'+car.name+'</div>';
		if(car.crash)
			html+='<div style="font:'+(14*this.scaleVal)+'px Arial;padding-top:'+(0*this.scaleVal)+'px;"><b>'+this.handler.config.menuTexts.Crashed+'</b></div>';
		else
			html+='<div style="font:'+(14*this.scaleVal)+'px Arial;padding-top:'+(0*this.scaleVal)+'px;"><b>'+this.handler.config.menuTexts.Speed+' '+Math.round(car.WPM)+' '+this.handler.config.menuTexts.WPM+'</b></div>';
		var minutes=0;var seconds=0;
		var time;
		if(car.crash)time=car.crashTime;else time=car.finishTime;
		time-=this.handler.raceTime;
		if(time<0)time=0;
		minutes=Math.floor(time/60000);
		time-=minutes*60000;
		seconds=Math.floor(time/1000);
		if(minutes<=9)minutes='0'+minutes;
		if(seconds<=9)seconds='0'+seconds;
		html+='<div style="font:'+(14*this.scaleVal)+'px Arial;padding-top:'+(2*this.scaleVal)+'px;"><b>'+this.handler.config.menuTexts.Time+' '+minutes+':'+seconds+'</b></div>';
		html+='<div style="font:'+(14*this.scaleVal)+'px Arial;padding-top:'+(2*this.scaleVal)+'px;"><b>'+this.handler.config.menuTexts.Points+' '+car.points+'</b></div>';
		html+='</div>';
		return html;
	}
	
	this.getPlayerCarReport=getPlayerCarReport;function getPlayerCarReport(){
		var html='';
		var car=this.handler.cars[0];
		var i=0;
		for(i=0;i<this.handler.cars.length;i++)if(this.handler.cars[i].type=='PC')break;
		if(i<this.handler.cars.length)car=this.handler.cars[i];
		var img=this.handler.assets.Data.Images['carImg_'+car.car.carType+'_0'];

		var time;
		if(car.crash)time=car.crashTime;else time=car.finishTime;
		time-=this.handler.raceTime;
		if(time<0)time=0;
		var minutes=Math.floor(time/60000);
		time-=minutes*60000;
		var seconds=Math.floor(time/1000);
		if(minutes<=9)minutes='0'+minutes;
		if(seconds<=9)seconds='0'+seconds;

		html+='<div align="center" style="padding-left:'+(30*this.scaleVal)+'px">';
		html+='<div style="height:'+(100*this.scaleVal)+'px;" align="left"><img src="'+img.src+'" width="'+(img.width*this.scaleVal/2)+'" height="'+(img.height*this.scaleVal/2)+'" style="padding-top:'+((100-img.height/2)*this.scaleVal)+'px;" /></div>';
		html+='<table style="border:solid 5px #5d5d5f;width:'+(900*this.scaleVal)+'px;font:'+(20*this.scaleVal)+'px Arial;" cellspacing="0" cellpadding="'+(2*this.scaleVal)+'">';
		html+='<tr><td colspan="2" style="background-color:#dbdbdb;font:'+(28*this.scaleVal)+'px airstrike;" align="center">'+this.handler.config.menuTexts.Statistics+'</td></tr>';
		html+='<tr style="background-color:#969799;"><td style="border-right:solid 2px #717274;padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Score+'</td><td style="padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Rating+'</td></tr>';
		html+='<tr style="background-color:#b3b3b5;"><td style="border-right:solid 2px #868688;padding-left:'+(10*this.scaleVal)+'px;">'+(car.crash?('<span style="color:#f00">'+this.handler.config.menuTexts.Crashed+'</span>'):(Math.round(car.WPM)+' '+this.handler.config.menuTexts.WPM))+'</td><td style="padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Points+' '+car.points+'</td></tr>';
		html+='<tr style="background-color:#969799;"><td style="border-right:solid 2px #717274;padding-left:'+(10*this.scaleVal)+'px;">'+(car.crash?(''):(this.handler.config.menuTexts.SuccessRate+': '+Math.round(car.position/(car.position+car.ERR)*100)+'%'))+'</td><td style="padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Money+'</td></tr>';
		html+='<tr style="background-color:#b3b3b5;"><td style="border-right:solid 2px #868688;padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.Time+' '+minutes+':'+seconds+'</td><td style="padding-left:'+(10*this.scaleVal)+'px;">'+this.handler.config.menuTexts.AccBonus+'</td></tr>';
		html+='</table></div>';
		return(html);
	}
	
	this.getGarrage=getGarrage;function getGarrage(set){
		if(this.handler.loadingStage<1)return;
		if(!this.handler.player){this.loginScreen1(set);return;}
		if(set){
			if(this.slideDoor && this.slideDoor>145){
				var obj;
				this.slideDoor-=10;
				if(this.slideDoor<145)slideDoor=145;
				if(this.slideDoor==145){
					obj=document.getElementById('garrageArrowL');
					if(obj)obj.style.zIndex=5;
					obj=document.getElementById('garrageArrowR');
					if(obj)obj.style.zIndex=5;
				}
				obj=document.getElementById('garrageDoor');
				if(obj)
					obj.style.backgroundPosition='0px '+((this.slideDoor-555)*this.scaleVal)+'px';
			}
			this.garrageChange();
		}else{
			this.slideDoor=0;
			this.GcarPos=0,GcarDir=0;
			var html=''
			html+='<div style="z-index:1;position:absolute;margin-left:'+(325*this.scaleVal)+'px;margin-top:'+(215*this.scaleVal)+'px;width:'+(608*this.scaleVal)+'px;height:'+(365*this.scaleVal)+'px;background-size:100%;background-image:url('+this.handler.assets.Data.Images.garrageHolders.src+');">???</div>';
			html+='<div style="z-index:2;" id="garrageCarContainer"></div>';
			html+='<div id="garrageDoor" style="z-index:3;margin-left:'+(305*this.scaleVal)+'px;margin-top:'+(85*this.scaleVal)+'px;width:'+(655*this.scaleVal)+'px;height:'+(555*this.scaleVal)+'px;background-image:url('+this.handler.assets.Data.Images.garrageClose.src+');"></div>';
			html+='<div id="garrageArrowL" class="garrageArrow" onclick="game.UI.garrageChange(-1);" style="width:'+(55*this.scaleVal)+'px;height:'+(45*this.scaleVal)+'px;margin-top:'+(580*this.scaleVal)+'px;margin-left:'+(355*this.scaleVal)+'px;"></div>';
			html+='<div id="garrageArrowR" class="garrageArrow flippedImg" onclick="game.UI.garrageChange(1);" style="width:'+(55*this.scaleVal)+'px;height:'+(45*this.scaleVal)+'px;margin-top:'+(580*this.scaleVal)+'px;margin-left:'+(835*this.scaleVal)+'px;"></div>';
			html+='<div style="position:absolute;margin-left:'+(37*this.scaleVal)+'px;margin-top:'+(17*this.scaleVal)+'px;">';//50
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;" id="carUpgradeButt">'+this.getTextButtonCode(this.handler.config.menuTexts.CarUpgrade,'65',227,66,32,0,0,'carUpgradeButtonPress')+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;display:none;" id="carUpgradePanel">'+this.getTextButtonCode(this.handler.config.menuTexts.CarUpgrade,'65On',227,66,32,0,0,false)+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.GlobalRank,'65',227,66,32,0,0,'globalRankButtonPress')+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.RaceHistory,'65',227,66,32,0,0,'raceHistoryButtonPress')+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.ImprovementsGraph,'65',227,66,18,0,0,'improvementsGraphButtonPress')+'</div>';
				html+='<div style="margin-top:'+(50*this.scaleVal)+'px;">'+this.getTextButtonCode(this.handler.config.menuTexts.Share,'65',227,66,32,0,0,'shareButtonPress')+'</div>';
			html+='</div>';
			this.mainDiv.style.backgroundImage="url('"+this.handler.assets.Data.Images.garrageBG.src+"')";
			this.mainDiv.style.backgroundPosition='center';
			this.mainDiv.innerHTML=html;
			this.handler.player.car=new Ccar(this.handler,this.handler.player.carType,0);
			this.handler.player.car.DrawGarrage();
		}
	}
	
	this.garrageChange=garrageChange;function garrageChange(direction){
		if(direction){
			this.GcarDir=direction;
		}else{
			if(!this.GcarDir)return;
			this.GcarPos+=this.GcarDir;
			this.handler.player.car.DrawGarrage(this.GcarPos);
		}
	}
	
	this.carUpgradeButtonPress=carUpgradeButtonPress;function carUpgradeButtonPress(){
		var obj=document.getElementById('carUpgradeButt');
		if(obj)obj.style.display='none';
		obj=document.getElementById('carUpgradePanel');
		if(obj)obj.style.display='block';
		this.slideDoor=555;
	}
	
	this.globalRankButtonPress=globalRankButtonPress;function globalRankButtonPress(){
	}
	
	this.raceHistoryButtonPress=raceHistoryButtonPress;function raceHistoryButtonPress(){
	}
	
	this.improvementsGraphButtonPress=improvementsGraphButtonPress;function improvementsGraphButtonPress(){
	}
	
	this.shareButtonPress=shareButtonPress;function shareButtonPress(){
	}
	
	
	this.Load();
}

	function drawRotPic(image,X,Y,zoom,angle,Px,Py,ctx,scale){
		if(!ctx)return;
		ctx.save();
		ctx.translate((X+Px)*scale,(Y+Py)*scale);
		ctx.rotate(angle);
		ctx.drawImage(image,-Px*scale,-Py*scale,image.width*scale*zoom,image.height*scale*zoom);
		ctx.restore();
	}
	function drawPic(image,X,Y,zoom,ctx,scale){
		if(!ctx)return;
		ctx.drawImage(image,X*scale,Y*scale,image.width*scale*zoom,image.height*scale*zoom);
	}
